require('player')
require('bullettimer')


-------------------------------------------------------------------------------------
---------------------------------- Enemy Spawning -----------------------------------
-------------------------------------------------------------------------------------


enemy_speed = 200

enemies = {}
enemies.isDead = false
enemies.holdUpgrade = false



enemiesdead = {}
enemiesdead.remove = false

spawntimer = 0

function enemiesAppear(dt)
	spawntimer = spawntimer + dt
	if spawntimer >= 1 then
    enemiesSpawn(rndxpos, -50, "down")
    spawntimer = 0

  end
end

function randomEnemyPos(dt)				-- this function spawns the enemies anywhere between 25 and 445 on the x axis
	rndxpos = love.math.random(25, 445)
end


function enemiesSpawn(x,y,dir) 		-- this function actually spawns/generates the enemies
	table.insert(enemies, {width = 20, height = 50, x = rndxpos, y = - 50, dir = dir})
end




-------------------------------------------------------------------------------------
---------------------------------- Enemy Weapons ------------------------------------
-------------------------------------------------------------------------------------


enemybullet_speed = 300
enemybullets = {}

function enemybulletsSpawn(x,y,dir)
	table.insert(enemybullets, {width = 2, height = 4, x = x + 5, y = y, dir = dir})

end

function enemiesFiringupdate(dt)

	for i,v in ipairs(enemies) do
			 if player.x > v.x and					-- This code checks to see if player is within shooting distance of enemy
				player.x < (v.x + v.width) and
				(player.y - 200) > v.y and
				(player.y - 200) < (v.y + 75) then
					if gunReady then
						enemybulletsSpawn(v.x, v.y, "down")					-- Shooting code
						gunReady = false
					end
				end
	end

end

function enemybulletsDraw()							-- this code draws the enemy bullets to the screen
	for i,v in ipairs(enemybullets) do
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
		love.graphics.setColor(255,255,255)
	end
end

function updateEnemyBullets(dt)

	for i, v in ipairs(enemybullets) do
			if v.dir == "down" then
						v.y = v.y + enemybullet_speed  * dt -- this sets the speed of the rocket
			end
				if v.y > 700 then
						table.remove(enemybullets, i)
				end
	end

end


-------------------------------------------------------------------------------------
---------------------------------- Enemy AI/Movement --------------------------------
-------------------------------------------------------------------------------------


function enemiesMove(dt)					    -- This function and for loop sets the enemy speed, and also removes any enemies that
	for ii, vv in ipairs(enemies) do			-- are below 600 pixels on the y axis
		if vv.dir == "down" then
			vv.y = vv.y + enemy_speed * dt
		end
		if vv.y > 800 then
			table.remove(enemies, ii)
		end
		if vv.y > 32 then						-- These next lines make these enemies take a zig-zag path
			vv.x = vv.x - 1
		end
		if vv.y > 128 then
			vv.x = vv.x + 2
		end
		if vv.y > 256 then
			vv.x = vv.x - 2
		end
		if vv.y > 512 then
			vv.x = vv.x + 2
		end
		if vv.y > 800 then
			player.streak = 0
		end
	end
end



-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
--------------------------- File Based UPDATE and DRAW Functions --------------------
--------------------------- put all functions from above in these -------------------
--------------------------- to keep main.lua clear and easily read ------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------



function enemiesUPDATE(dt)

			enemiesMove(dt)
			enemiesAppear(dt)
			randomEnemyPos(dt)
			enemiesFiringupdate(dt)
			updateEnemyBullets(dt)



end

function enemiesDRAW()


			enemybulletsDraw()


end








