require "background"
require "player"
require "enemies"
require "arcenemies"
require "bullettimer"
require "weapons"
require "debugging"
require "AdditionalCameraFuncs"
require "collisions"
require "tanks"
require "footsoldiers"


local camera = require "camera"

local anim8 = require "anim8"

local image, animation


function love.load()


	love.graphics.setNewFont(18)

	image = love.graphics.newImage("sprites/JetSpritesSheet.png")
	expimage = love.graphics.newImage("sprites/explosion.png")
	local g = anim8.newGrid(46, 61, image:getWidth(), image:getHeight())
	local expl = anim8.newGrid(32, 32, image:getWidth(), image:getHeight())
	animation = anim8.newAnimation(g ("1 - 2",2), 0.1)
	shootanimation = anim8.newAnimation(g (1,1, 2,2), 0.1)
	enemyanimation = anim8.newAnimation(g ("1 - 2", 2), 0.1)
	explosionanimation = anim8.newAnimation(expl (1,1, 1,1), 0.1)


	tilemap() -- function located in background.lua that loads and sets the background tiles


-------------------------------------------------------------------------------------
-----------------------------Load Weapon/Ammo Images --------------------------------
-------------------------------------------------------------------------------------
	rocketsprite = love.graphics.newImage("sprites/rocket.png")

-------------------------------------------------------------------------------------
---------------------------------- Camera Load Stuff --------------------------------
-------------------------------------------------------------------------------------

	camera.setBoundary(0,0, 600, 20000) -- Width and height are in pixels


end





function love.update(dt)

print("Player.Y: " .. player.y)
print("Camera Y: " .. player.cameray)

	animation:update(dt)

	playerUPDATE(dt)

	enemiesUPDATE(dt)

	arcEnemiesUPDATE(dt)

	collisionsUPDATE(dt)

	debuggingUPDATE(dt)

	cameraUPDATE(dt)

	bullettimerUPDATE(dt)

	weaponsUPDATE(dt)

	tanksUPDATE(dt)

	footsoldiersUPDATE(dt)


	function bullet.shoot(key)
		if key == "r" then
			if heavymachinegunEquipped then
			heavymachineGun.spawn(player.x + player.width - 2, player.y + player.height/2, "")
			else
			bullet.spawn(player.x + player.width - 2, player.y + player.height/2, "right")
			end
		end
		if key == "e" then
		if heavymachinegunEquipped then
			heavymachineGun.spawn(player.x + player.width - 2, player.y + player.height/2, "")
			else
			bullet.spawn(player.x, player.y + player.height/2, "left")
			end
		end
		if key == " " then
			if quadrocketEquipped then
			quadrockets.spawn(player.x + player.width/2 - 2.5, player.y + player.height/2, "fast")
			else
			rocket.spawn(player.x + player.width/2 - 2.5, player.y + player.height/2, "fast")
			end
		end
	end



end






function love.draw(dt)

---------------------------------------------------------------------------------------------------------------
---------------------------------- stuff that DOES scroll in/out of screen ------------------------------------
---------------------------------------------------------------------------------------------------------------

	camera.lookAt(player.x, player.cameray) -- dictates what the camera is "attached" to -- currently it is attached to an invisible square that moves
											-- at a rate of 15 pixels per second - regardless of where the player is within the screen

	camera.draw(function() -- this function denotes what scrolls out and into the view of the camera.
		drawtilemap() -- draws each tile to the screen - function located in background.lua
		tanksDRAW()

		tankbulletsDraw()



		footsoldiersDRAW()
	end)



---------------------------------------------------------------------------------------------------------------
---------------------------------- stuff that DOESNT scroll out of screen -------------------------------------
---------------------------------------------------------------------------------------------------------------



	collisionsDRAW()

	cameraDRAW()

	bullettimerDRAW(dt)

	weaponsDRAW(dt)

	debuggingDRAW()

	playerDRAW()

	enemiesDRAW()

	arcEnemiesDRAW()




		-------------------------------------------------------------------------------------
		------------------------------ Draw Player Shadow -----------------------------------
		-------------------------------------------------------------------------------------


			if player.x > 0 and
				   player.x < 200 then
					love.graphics.setColor(0,0,0,125)
					shootanimation:draw(image, player.x - 50, player.y + 25)
					love.graphics.setColor(255,255,255)
				elseif player.x > 200 and
					   player.x < 400 then
					love.graphics.setColor(0,0,0,125)
					shootanimation:draw(image, player.x - 15, player.y + 25)
					love.graphics.setColor(255,255,255)
				elseif player.x > 400 and
					   player.x < 600 then
					love.graphics.setColor(0,0,0,125)
					shootanimation:draw(image, player.x + 30, player.y + 25)
					love.graphics.setColor(255,255,255)
			end



		-------------------------------------------------------------------------------------
		---------------------------------- Draw Player --------------------------------------
		-------------------------------------------------------------------------------------



			if love.keyboard.isDown("r") or
			   love.keyboard.isDown("e") then
					shootanimation:draw(image, player.x - 15, player.y)
				else
				 animation:draw(image, player.x - 15, player.y)
			end

		-------------------------------------------------------------------------------------
		---------------------------------- Draw Enemies --------------------------------------
		-------------------------------------------------------------------------------------

			for ii,vv in ipairs(enemies) do
				enemyanimation:draw(image, vv.x - 3, vv.y + 50, 0, 1, -1)
			end
			for iii,vvv in ipairs(arcenemies)do
				enemyanimation:draw(image, vvv.x - 3, vvv.y + 50, 0, 1, -1)
			end


end




function love.keypressed(key)
	bullet.shoot(key)
end





