require('enemies')
require('collisions')

-------------------------------------------------------------------------------------
---------------------------------- Player Firing ------------------------------------
-------------------------------------------------------------------------------------

--in main.lua update()


-------------------------------------------------------------------------------------
---------------------------------- Basic Rockets-------------------------------------
-------------------------------------------------------------------------------------


rocket_speed = 300
rocket = {}
rocket.damage = 2



function rocket.spawn(x,y,dir)
	table.insert(rocket, {width = 4, height = 10, x = x, y = y, dir = dir})
end


function updateRockets(dt)

		for i, v in ipairs(rocket) do
			if v.dir == "fast" then
						v.y = v.y - rocket_speed * dt -- this sets the speed of the rocket
			end
				if v.y < 50 then
						table.remove(rocket, i)
				end
		end
end

function rocket.draw()
	for i,v in ipairs(rocket) do
	love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
	love.graphics.setColor(255,255,255)
	end
end

-------------------------------------------------------------------------------------
---------------------------------- Quad Rockets-------------------------------------
-------------------------------------------------------------------------------------

quadrocketEquipped = false -- sets default of quad rockets to false

quadrockets = {}
quadrockets.speed = 100
quadrockets.damage = 2

function quadrockets.spawn(x,y,dir,distance)
	table.insert(quadrockets, {width = 4, height = 10, x = x, y = y, dir = "left1", distance = 0}) -- these four lines are the individual rockets that
	table.insert(quadrockets, {width = 4, height = 10, x = x, y = y, dir = "left2", distance = 0}) -- shoot out of the ship, spread, and then shoot upwards.
	table.insert(quadrockets, {width = 4, height = 10, x = x, y = y, dir = "right2", distance = 0})
	table.insert(quadrockets, {width = 4, height = 10, x = x, y = y, dir = "right1", distance = 0})
end


	function updatequadrockets(dt)

		for i,v in ipairs(quadrockets) do
			if v.dir == "right1" and
				v.distance < 10 then
						v.x = v.x + 100 * dt
						v.distance = v.distance + 1
			else
						v.x = v.x
						v.y = v.y - quadrockets.speed * dt -- this sets the speed of the rocket
			end

		end

		for i,v in ipairs(quadrockets) do
			if v.dir == "right2" and
				v.distance < 10 then
						v.x = v.x + 200 * dt
						v.distance = v.distance + 1
			else
						v.x = v.x
						v.y = v.y - quadrockets.speed * dt -- this sets the speed of the rocket
			end

		end

		for i,v in ipairs(quadrockets) do
			if v.dir == "left2" and
				v.distance < 10 then
						v.x = v.x - 110 * dt
						v.distance = v.distance + 1
			else
						v.x = v.x
						v.y = v.y - quadrockets.speed * dt -- this sets the speed of the rocket
			end

		end

		for i,v in ipairs(quadrockets) do
			if v.dir == "left1" and
				v.distance < 10 then
						v.x = v.x - 210 * dt
						v.distance = v.distance + 1
			else
						v.x = v.x
						v.y = v.y - quadrockets.speed * dt -- this sets the speed of the rocket
			end

		end

		for i,v in ipairs(quadrockets) do -- this removes the rocket if it goes below 50 on the y axis.
			if v.y < 50 then
				table.remove(quadrockets, i)
			end
		end

	end

function quadrockets.draw()
	for i,v in ipairs(quadrockets) do
	love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
	love.graphics.setColor(255,255,255)
	end
end



-------------------------------------------------------------------------------------
---------------------------------- Basic Machine Gun --------------------------------
-------------------------------------------------------------------------------------

bullet_speed = 250
bullet = {}
bullet.damage = 1


function bullet.spawn(x,y,dir)
	table.insert(bullet, {width = 2, height = 4, x = x, y = y, dir = dir})
end


function updateBullets(dt)
	for i,v in ipairs(bullet) do
		if  v.dir == "right" or
			v.dir == "left" then
			v.y = v.y - bullet_speed * dt -- this sets the speed of the bullet on the right side of the player
		end
			if v.y < 50 then
					table.remove(bullet, i)
			end
	end
end


function bullet.draw()
	for i,v in ipairs(bullet) do
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
		love.graphics.setColor(255,255,255)
	end
end
-------------------------------------------------------------------------------------
---------------------------------- Heavy Machine Gun --------------------------------
-------------------------------------------------------------------------------------

heavymachinegunEquipped = false


heavymachineGun = {}
heavymachineGun_speed = 500
heavymachineGun.damage = 1

function heavymachineGun.spawn(x,y,dir)
	table.insert(heavymachineGun, {width = 2, height = 4, x = x - 5, y = y, dir = "one"})
	table.insert(heavymachineGun, {width = 2, height = 4, x = x - 5, y = y, dir = "two"})
	table.insert(heavymachineGun, {width = 2, height = 4, x = x - 10, y = y, dir = "three"})
	table.insert(heavymachineGun, {width = 2, height = 4, x = x - 10, y = y, dir = "four"})
end


function updateHeavyGunBullets(dt)

	for i,v in ipairs(heavymachineGun) do
			if v.dir == "one" then
				v.y = v.y - heavymachineGun_speed * dt -- this sets the speed of the bullets
				v.x = v.x + 50 * dt
			end
				if v.y < 25 or
				   v.x < 25 or
				   v.x > 575 then
						table.remove(heavymachineGun, i)
				end
	end
	for i,v in ipairs(heavymachineGun) do
			if v.dir == "two" then
				v.y = v.y - heavymachineGun_speed * dt -- this sets the speed of the bullets
				v.x = v.x + 100 * dt
			end
				if v.y < 25 or
				   v.x < 25 or
				   v.x > 575 then
						table.remove(heavymachineGun, i)
				end
	end
	for i,v in ipairs(heavymachineGun) do
			if v.dir == "three" then
				v.y = v.y - heavymachineGun_speed * dt -- this sets the speed of the bullets
				v.x = v.x - 50 * dt
			end
				if v.y < 25 or
				   v.x < 25 or
				   v.x > 575 then
						table.remove(heavymachineGun, i)
				end
	end
	for i,v in ipairs(heavymachineGun) do
			if v.dir == "four" then
				v.y = v.y - heavymachineGun_speed * dt -- this sets the speed of the bullets
				v.x = v.x - 100 * dt
			end
				if v.y < 25 or
				   v.x < 25 or
				   v.x > 575 then
						table.remove(heavymachineGun, i)
				end
	end

end

function heavygunbulletDraw()
	for i,v in ipairs(heavymachineGun) do
	love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
	love.graphics.setColor(255,255,255)
	end
end






--------------------------------------------------------------------------------------
----------------- These functions spawn an upgrade whenever an enemy dies ------------
----------------- and places the upgrade in the x y position in which the ------------
------------------------------------ enemy was killed --------------------------------
--------------------------------------------------------------------------------------

--upgradeAvailable = false

upgrades = {}


function upgradeRandomizer() -- this function will eventually randomize the upgrade which comes available

end



function deathRandomizer() -- this function will eventually randomize the enemy which holds the upgrades (so not all enemies drop upgrades)

end

upgradetimer = 0


function upgradesAppear(dt) -- this function tells when to run the upgradesSpawn function below
	if upgradeAvailable == true then
         upgradesSpawn(x, y)
		 upgradeAvailable = false
	end
end


function upgradesSpawn(x,y) 		-- this function actually spawns the upgrades (that will eventually fall from destroyed ships)
	for i,v in ipairs(enemies) do
			if v.isDead == true and  -- this checks whether the enemy has been killed
			   v.holdUpgrade == true then -- this checks to see if this particular enemy
				table.insert(upgrades, {width = 40, height = 40, x = v.x, y = v.y}) -- if it has it spawns an upgrade at the enemies x and y position
				table.remove(enemies,i) -- it then removes the enemy from the table (and screen)
			else if v.isDead == true then
				table.remove(enemies,i) -- it then removes the enemy from the table (and screen)
			end
			end
	end
end



function enemiesHoldUpgrade(dt)  -- this codes says that if the players streak is 5 then any enemy that is above the screen now holds an upgrade
			for i,v in ipairs(enemies) do
				if player.streak == 2 then
				if v.y < -30 then
				v.holdUpgrade = true

				end
				end
			end
end


function keepUpgradeOnScreen()
			for i,v in ipairs(enemies) do
				if v.holdUpgrade == true and
				   v.y > 800 then
				   v.holdUpgrade = false
				end
			end
end


function upgradesDraw()  -- this draws the upgrades to the screen
	for i,v in ipairs(upgrades) do
		love.graphics.setColor(4,178,254)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
		love.graphics.setColor(255,255,255)
	end
end










function equipUpgrade()
	for i,v in ipairs(upgrades) do
		if  (player.x + player.width) >= v.x and
		player.x <= (v.x + v.width) and
		(player.y + player.height) >= v.y and
		player.y <= (v.y + v.height) then
		table.remove(upgrades, i)
		quadrocketEquipped = true
		heavymachinegunEquipped = true
		end
	end
end








-------------------------------------------------------------------------------------
----------------- Resets Weapons To Basic If Streak Goes to Zero---------------------
-------------------------------------------------------------------------------------




function playerWeaponReset()
		if player.streak == 0 then
			heavymachinegunEquipped = false
			quadrocketEquipped = false
		end
end




-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
--------------------------- File Based UPDATE and DRAW Functions --------------------
--------------------------- put all functions from above in these -------------------
--------------------------- to keep main.lua clear and easily read ------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------


function weaponsUPDATE(dt)

			updateRockets(dt)
			updateBullets(dt)

			upgradesAppear(dt)

			enemiesHoldUpgrade(dt)
			keepUpgradeOnScreen()

			upgradeRandomizer()

			--- Individual Pickup Upgrades ---
			equipUpgrade()


			updateHeavyGunBullets(dt)
			updatequadrockets(dt)
			playerWeaponReset()

end

function weaponsDRAW()

			upgradesDraw()

			bullet.draw()
			rocket.draw()

			quadrockets.draw()
			heavygunbulletDraw()

end








